package encryptionproject;

import java.awt.*;
import java.util.Random;

class EncryptionVernamMethod extends EncryptionMethod
{

    public EncryptionVernamMethod()
    {
    }

    public String encrypt(String s, TutorialDisplay tutorialdisplay)
    {
        Random random = new Random();
        StringBuffer stringbuffer = new StringBuffer(s.length());
        int ai[] = new int[s.length()];
        tutorialdisplay.addText("\n===============\nVernam Cipher");
        for(int j = 0; j < s.length(); j++)
        {
            char c = s.charAt(j);
            if(Character.isLetter(c))
            {
                int i = (int)(random.nextDouble() * 100D);
                tutorialdisplay.addText("Converting: " + c + "\n");
                tutorialdisplay.addText("Num. equivalent: " + (Character.toUpperCase(c) - 65) + "\n");
                tutorialdisplay.addText("Random Num: " + i + "\n");
                tutorialdisplay.addText("Sum: " + ((Character.toUpperCase(c) - 65) + i) + "\n");
                tutorialdisplay.addText("Mod 26: " + ((Character.toUpperCase(c) - 65) + i) % 26 + "\n");
                tutorialdisplay.addText("CipherText: " + (char)(((Character.toUpperCase(c) - 65) + i) % 26 + 65) + "\n\n");
                ai[j] = i;
                stringbuffer.append((char)(((Character.toUpperCase(c) - 65) + i) % 26 + 65));
            } else
            {
                stringbuffer.append(c);
            }
        }

        tutorialdisplay.addText("One Time Pad: ");
        for(int k = 0; k < s.length(); k++)
            tutorialdisplay.addText(ai[k] + " ");

        return stringbuffer.toString();
    }

    public Panel getOptionsPanel()
    {
        Panel panel = new Panel(new BorderLayout());
        panel.add(new Label("No options available for Vernam Cipher"));
        panel.setBackground(new Color(192, 192, 255));
        return panel;
    }
}
